Tonyu.klass.define({
  fullName: 'user.Main',
  shortName: 'Main',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Main_main() {
        "use strict";
        var _this=this;
        
        
        
        
        
        
        
        Tonyu.globals.$numRect=300;
        Tonyu.globals.$screenH=1000;
        Tonyu.globals.$screenW=1000;
        Tonyu.globals.$regionH=800;
        Tonyu.globals.$regionW=800;
        Tonyu.globals.$regionSx=(Tonyu.globals.$screenW-Tonyu.globals.$regionW)/2;
        Tonyu.globals.$regionSy=(Tonyu.globals.$screenH-Tonyu.globals.$regionH)/2;
        Tonyu.globals.$rectWmin=20;
        Tonyu.globals.$rectHmin=20;
        Tonyu.globals.$rectWmax=100;
        Tonyu.globals.$rectHmax=100;
        _this.init();
        while (1) {
          _this.move();
          _this.update();
          
        }
      },
      fiber$main :function* _trc_Main_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        
        
        
        
        
        
        
        Tonyu.globals.$numRect=300;
        Tonyu.globals.$screenH=1000;
        Tonyu.globals.$screenW=1000;
        Tonyu.globals.$regionH=800;
        Tonyu.globals.$regionW=800;
        Tonyu.globals.$regionSx=(Tonyu.globals.$screenW-Tonyu.globals.$regionW)/2;
        Tonyu.globals.$regionSy=(Tonyu.globals.$screenH-Tonyu.globals.$regionH)/2;
        Tonyu.globals.$rectWmin=20;
        Tonyu.globals.$rectHmin=20;
        Tonyu.globals.$rectWmax=100;
        Tonyu.globals.$rectHmax=100;
        (yield* _this.fiber$init(_thread));
        while (1) {
          (yield* _this.fiber$move(_thread));
          (yield* _this.fiber$update(_thread));
          
        }
        
      },
      appearRect :function _trc_Main_appearRect() {
        "use strict";
        var _this=this;
        
        _this.rects.push(new Tonyu.classes.user.Rect({x: Tonyu.globals.$regionSx+Tonyu.globals.$rectWmax/2+_this.rnd(Tonyu.globals.$regionW-Tonyu.globals.$rectWmax),y: Tonyu.globals.$regionSy+Tonyu.globals.$rectHmax/2+_this.rnd(Tonyu.globals.$regionH-Tonyu.globals.$rectHmax),width: Tonyu.globals.$rectWmin+_this.rnd(Tonyu.globals.$rectWmax-Tonyu.globals.$rectWmin),height: Tonyu.globals.$rectHmin+_this.rnd(Tonyu.globals.$rectHmax-Tonyu.globals.$rectHmin),fillStyle: _this.color(247,195,191)}));
      },
      fiber$appearRect :function* _trc_Main_f_appearRect(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        
        _this.rects.push(new Tonyu.classes.user.Rect({x: Tonyu.globals.$regionSx+Tonyu.globals.$rectWmax/2+_this.rnd(Tonyu.globals.$regionW-Tonyu.globals.$rectWmax),y: Tonyu.globals.$regionSy+Tonyu.globals.$rectHmax/2+_this.rnd(Tonyu.globals.$regionH-Tonyu.globals.$rectHmax),width: Tonyu.globals.$rectWmin+_this.rnd(Tonyu.globals.$rectWmax-Tonyu.globals.$rectWmin),height: Tonyu.globals.$rectHmin+_this.rnd(Tonyu.globals.$rectHmax-Tonyu.globals.$rectHmin),fillStyle: _this.color(247,195,191)}));
        
      },
      deleteRect :function _trc_Main_deleteRect() {
        "use strict";
        var _this=this;
        
        if (! _this.rects.length) {
          return _this;
        }
        _this.rects[_this.rects.length-1].die();
        _this.rects.pop();
      },
      fiber$deleteRect :function* _trc_Main_f_deleteRect(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        
        if (! _this.rects.length) {
          return _this;
        }
        _this.rects[_this.rects.length-1].die();
        _this.rects.pop();
        
      },
      init :function _trc_Main_init() {
        "use strict";
        var _this=this;
        var m;
        var i;
        
        Tonyu.globals.$Boot.newLimit=10000;
        _this.update();
        Tonyu.globals.$Screen.resize(Tonyu.globals.$screenW,Tonyu.globals.$screenH);
        Tonyu.globals.$Screen.setBGColor("#8ac8cf");
        _this.naiveManager=new Tonyu.classes.user.NaiveManager({});
        _this.quadTreeManager=new Tonyu.classes.user.QuadTreeManager({});
        _this.managers=[_this.naiveManager,_this.quadTreeManager];
        _this.modes=["Naive Manager","Quad Tree Manager"];
        _this.managerInd=1;
        for ([m] of Tonyu.iterator2(_this.managers,1)) {
          m.init();
          
        }
        new Tonyu.classes.kernel.Label({x: 0,y: 0,template: "$mode",size: 30,color: _this.color(239,235,224),align: "left top",layer: Tonyu.globals.$frontLayer});
        new Tonyu.classes.kernel.Label({x: 0,y: 30,template: "N: $numRect, Call: $callCount, Detected: $detectedCount",size: 30,color: _this.color(239,235,224),align: "left top",layer: Tonyu.globals.$frontLayer});
        new Tonyu.classes.kernel.Label({x: Tonyu.globals.$screenW,y: Tonyu.globals.$screenH,template: "FPS: $fps",size: 30,color: _this.color(239,235,224),align: "right bottom",layer: Tonyu.globals.$frontLayer});
        new Tonyu.classes.kernel.Label({x: 0,y: Tonyu.globals.$screenH-30,template: "press [↑↓] to change N",size: 30,color: _this.color(239,235,224),align: "left bottom",layer: Tonyu.globals.$frontLayer});
        new Tonyu.classes.kernel.Label({x: 0,y: Tonyu.globals.$screenH,template: "press [z] to change manager",size: 30,color: _this.color(239,235,224),align: "left bottom",layer: Tonyu.globals.$frontLayer});
        new Tonyu.classes.kernel.Actor({x: Tonyu.globals.$screenH/2,y: Tonyu.globals.$screenW/2,width: Tonyu.globals.$regionH,height: Tonyu.globals.$regionW,fillStyle: _this.color(239,235,224)});
        _this.rects=[];
        for (i = 0;
         i<Tonyu.globals.$numRect ; i++) {
          {
            _this.appearRect();
          }
        }
      },
      fiber$init :function* _trc_Main_f_init(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var m;
        var i;
        
        Tonyu.globals.$Boot.newLimit=10000;
        (yield* _this.fiber$update(_thread));
        Tonyu.globals.$Screen.resize(Tonyu.globals.$screenW,Tonyu.globals.$screenH);
        Tonyu.globals.$Screen.setBGColor("#8ac8cf");
        _this.naiveManager=new Tonyu.classes.user.NaiveManager({});
        _this.quadTreeManager=new Tonyu.classes.user.QuadTreeManager({});
        _this.managers=[_this.naiveManager,_this.quadTreeManager];
        _this.modes=["Naive Manager","Quad Tree Manager"];
        _this.managerInd=1;
        for ([m] of Tonyu.iterator2(_this.managers,1)) {
          m.init();
          
        }
        new Tonyu.classes.kernel.Label({x: 0,y: 0,template: "$mode",size: 30,color: _this.color(239,235,224),align: "left top",layer: Tonyu.globals.$frontLayer});
        new Tonyu.classes.kernel.Label({x: 0,y: 30,template: "N: $numRect, Call: $callCount, Detected: $detectedCount",size: 30,color: _this.color(239,235,224),align: "left top",layer: Tonyu.globals.$frontLayer});
        new Tonyu.classes.kernel.Label({x: Tonyu.globals.$screenW,y: Tonyu.globals.$screenH,template: "FPS: $fps",size: 30,color: _this.color(239,235,224),align: "right bottom",layer: Tonyu.globals.$frontLayer});
        new Tonyu.classes.kernel.Label({x: 0,y: Tonyu.globals.$screenH-30,template: "press [↑↓] to change N",size: 30,color: _this.color(239,235,224),align: "left bottom",layer: Tonyu.globals.$frontLayer});
        new Tonyu.classes.kernel.Label({x: 0,y: Tonyu.globals.$screenH,template: "press [z] to change manager",size: 30,color: _this.color(239,235,224),align: "left bottom",layer: Tonyu.globals.$frontLayer});
        new Tonyu.classes.kernel.Actor({x: Tonyu.globals.$screenH/2,y: Tonyu.globals.$screenW/2,width: Tonyu.globals.$regionH,height: Tonyu.globals.$regionW,fillStyle: _this.color(239,235,224)});
        _this.rects=[];
        for (i = 0;
         i<Tonyu.globals.$numRect ; i++) {
          {
            (yield* _this.fiber$appearRect(_thread));
          }
        }
        
      },
      move :function _trc_Main_move() {
        "use strict";
        var _this=this;
        
        Tonyu.globals.$fps=Tonyu.globals.$Boot.getMeasuredFps();
        _this.managers[_this.managerInd].move();
        if (_this.getkey(90)==1) {
          _this.managerInd=1-_this.managerInd;
          _this.managers[_this.managerInd].init();
          
        }
        if (_this.getkey(38)%3==1) {
          _this.appearRect();
          
        }
        if (_this.getkey(40)%3==1) {
          _this.deleteRect();
          
        }
        Tonyu.globals.$mode=_this.modes[_this.managerInd];
        Tonyu.globals.$numRect=_this.rects.length;
      },
      fiber$move :function* _trc_Main_f_move(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        
        Tonyu.globals.$fps=Tonyu.globals.$Boot.getMeasuredFps();
        _this.managers[_this.managerInd].move();
        if (_this.getkey(90)==1) {
          _this.managerInd=1-_this.managerInd;
          _this.managers[_this.managerInd].init();
          
        }
        if (_this.getkey(38)%3==1) {
          (yield* _this.fiber$appearRect(_thread));
          
        }
        if (_this.getkey(40)%3==1) {
          (yield* _this.fiber$deleteRect(_thread));
          
        }
        Tonyu.globals.$mode=_this.modes[_this.managerInd];
        Tonyu.globals.$numRect=_this.rects.length;
        
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false,"isMain":true,"vtype":{"params":[],"returnValue":null}},"appearRect":{"nowait":false,"isMain":false,"vtype":{"params":[],"returnValue":null}},"deleteRect":{"nowait":false,"isMain":false,"vtype":{"params":[],"returnValue":null}},"init":{"nowait":false,"isMain":false,"vtype":{"params":[],"returnValue":null}},"move":{"nowait":false,"isMain":false,"vtype":{"params":[],"returnValue":null}}},"fields":{"managers":{},"managerInd":{},"quadTreeManager":{},"naiveManager":{},"modes":{},"rects":{}}}
});
Tonyu.klass.define({
  fullName: 'user.CollisionManager',
  shortName: 'CollisionManager',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_CollisionManager_main() {
        "use strict";
        var _this=this;
        
      },
      fiber$main :function* _trc_CollisionManager_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        
        
      },
      init :function _trc_CollisionManager_init() {
        "use strict";
        var _this=this;
        
      },
      fiber$init :function* _trc_CollisionManager_f_init(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        
        
      },
      move :function _trc_CollisionManager_move() {
        "use strict";
        var _this=this;
        
        Tonyu.globals.$callCount=0;
        Tonyu.globals.$detectedCount=0;
      },
      fiber$move :function* _trc_CollisionManager_f_move(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        
        Tonyu.globals.$callCount=0;
        Tonyu.globals.$detectedCount=0;
        
      },
      doCrashTo :function _trc_CollisionManager_doCrashTo(obj1,obj2) {
        "use strict";
        var _this=this;
        var ret;
        
        Tonyu.globals.$callCount++;
        ret = obj1.crashTo(obj2);
        
        if (ret) {
          _this.drawLine(obj1.x,obj1.y,obj2.x,obj2.y,_this.color(138,200,207),- 10);
        }
        return ret;
      },
      fiber$doCrashTo :function* _trc_CollisionManager_f_doCrashTo(_thread,obj1,obj2) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var ret;
        
        Tonyu.globals.$callCount++;
        ret = obj1.crashTo(obj2);
        
        if (ret) {
          _this.drawLine(obj1.x,obj1.y,obj2.x,obj2.y,_this.color(138,200,207),- 10);
        }
        return ret;
        
      },
      countUp :function _trc_CollisionManager_countUp() {
        "use strict";
        var _this=this;
        
        Tonyu.globals.$detectedCount++;
      },
      fiber$countUp :function* _trc_CollisionManager_f_countUp(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        
        Tonyu.globals.$detectedCount++;
        
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false,"isMain":true,"vtype":{"params":[],"returnValue":null}},"init":{"nowait":false,"isMain":false,"vtype":{"params":[],"returnValue":null}},"move":{"nowait":false,"isMain":false,"vtype":{"params":[],"returnValue":null}},"doCrashTo":{"nowait":false,"isMain":false,"vtype":{"params":[null,null],"returnValue":null}},"countUp":{"nowait":false,"isMain":false,"vtype":{"params":[],"returnValue":null}}},"fields":{}}
});
Tonyu.klass.define({
  fullName: 'user.NaiveManager',
  shortName: 'NaiveManager',
  namespace: 'user',
  superclass: Tonyu.classes.user.CollisionManager,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_NaiveManager_main() {
        "use strict";
        var _this=this;
        
      },
      fiber$main :function* _trc_NaiveManager_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        
        
      },
      init :function _trc_NaiveManager_init() {
        "use strict";
        var _this=this;
        
        __superClass.prototype.init.apply( _this, []);
      },
      fiber$init :function* _trc_NaiveManager_f_init(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        
        (yield* __superClass.prototype.fiber$init.apply( _this, [_thread]));
        
      },
      move :function _trc_NaiveManager_move() {
        "use strict";
        var _this=this;
        var rects;
        var t1;
        var i1;
        var i2;
        
        __superClass.prototype.move.apply( _this, []);
        rects = [];
        
        for ([t1] of Tonyu.iterator2(_this.all(Tonyu.classes.user.Rect),1)) {
          rects.push(t1);
          
        }
        for (i1 = 0;
         i1<rects.length ; i1++) {
          {
            for (i2 = i1+1;
             i2<rects.length ; i2++) {
              {
                if (_this.doCrashTo(rects[i1],rects[i2])) {
                  _this.countUp();
                  
                }
              }
            }
          }
        }
      },
      fiber$move :function* _trc_NaiveManager_f_move(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var rects;
        var t1;
        var i1;
        var i2;
        
        (yield* __superClass.prototype.fiber$move.apply( _this, [_thread]));
        rects = [];
        
        for ([t1] of Tonyu.iterator2(_this.all(Tonyu.classes.user.Rect),1)) {
          rects.push(t1);
          
        }
        for (i1 = 0;
         i1<rects.length ; i1++) {
          {
            for (i2 = i1+1;
             i2<rects.length ; i2++) {
              {
                if (_this.doCrashTo(rects[i1],rects[i2])) {
                  (yield* _this.fiber$countUp(_thread));
                  
                }
              }
            }
          }
        }
        
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false,"isMain":true,"vtype":{"params":[],"returnValue":null}},"init":{"nowait":false,"isMain":false,"vtype":{"params":[],"returnValue":null}},"move":{"nowait":false,"isMain":false,"vtype":{"params":[],"returnValue":null}}},"fields":{}}
});
Tonyu.klass.define({
  fullName: 'user.QuadTreeManager',
  shortName: 'QuadTreeManager',
  namespace: 'user',
  superclass: Tonyu.classes.user.CollisionManager,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_QuadTreeManager_main() {
        "use strict";
        var _this=this;
        
        
        
        
        
      },
      fiber$main :function* _trc_QuadTreeManager_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        
        
        
        
        
        
      },
      init :function _trc_QuadTreeManager_init() {
        "use strict";
        var _this=this;
        var d;
        var l;
        
        __superClass.prototype.init.apply( _this, []);
        _this.maxLevel=4;
        _this.offsetTable=[0];
        d = 1;
        
        for (l = 1;
         l<=_this.maxLevel ; l++) {
          {
            _this.offsetTable.push(_this.offsetTable[_this.offsetTable.length-1]+d);
            d*=4;
          }
        }
        _this.maxN=_this.offsetTable[_this.offsetTable.length-1]+d;
      },
      fiber$init :function* _trc_QuadTreeManager_f_init(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var d;
        var l;
        
        (yield* __superClass.prototype.fiber$init.apply( _this, [_thread]));
        _this.maxLevel=4;
        _this.offsetTable=[0];
        d = 1;
        
        for (l = 1;
         l<=_this.maxLevel ; l++) {
          {
            _this.offsetTable.push(_this.offsetTable[_this.offsetTable.length-1]+d);
            d*=4;
          }
        }
        _this.maxN=_this.offsetTable[_this.offsetTable.length-1]+d;
        
      },
      separate32 :function _trc_QuadTreeManager_separate32(n) {
        "use strict";
        var _this=this;
        
        n=(n|(n<<8))&16711935;
        n=(n|(n<<4))&252645135;
        n=(n|(n<<2))&858993459;
        return (n|(n<<1))&1431655765;
      },
      fiber$separate32 :function* _trc_QuadTreeManager_f_separate32(_thread,n) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        
        n=(n|(n<<8))&16711935;
        n=(n|(n<<4))&252645135;
        n=(n|(n<<2))&858993459;
        return (n|(n<<1))&1431655765;
        
      },
      count32bit :function _trc_QuadTreeManager_count32bit(v) {
        "use strict";
        var _this=this;
        var count;
        
        count = (v&1431655765)+((v>>1)&1431655765);
        
        count=(count&858993459)+((count>>2)&858993459);
        count=(count&252645135)+((count>>4)&252645135);
        count=(count&16711935)+((count>>8)&16711935);
        return (count&65535)+((count>>16)&65535);
      },
      fiber$count32bit :function* _trc_QuadTreeManager_f_count32bit(_thread,v) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var count;
        
        count = (v&1431655765)+((v>>1)&1431655765);
        
        count=(count&858993459)+((count>>2)&858993459);
        count=(count&252645135)+((count>>4)&252645135);
        count=(count&16711935)+((count>>8)&16711935);
        return (count&65535)+((count>>16)&65535);
        
      },
      MSB32 :function _trc_QuadTreeManager_MSB32(v) {
        "use strict";
        var _this=this;
        
        v=v|(v>>1);
        v=v|(v>>2);
        v=v|(v>>4);
        v=v|(v>>8);
        v=v|(v>>16);
        return _this.count32bit(v)-1;
      },
      fiber$MSB32 :function* _trc_QuadTreeManager_f_MSB32(_thread,v) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        
        v=v|(v>>1);
        v=v|(v>>2);
        v=v|(v>>4);
        v=v|(v>>8);
        v=v|(v>>16);
        return _this.count32bit(v)-1;
        
      },
      get2DMortonNumber :function _trc_QuadTreeManager_get2DMortonNumber(x,y) {
        "use strict";
        var _this=this;
        
        return (_this.separate32(x)|(_this.separate32(y)<<1));
      },
      fiber$get2DMortonNumber :function* _trc_QuadTreeManager_f_get2DMortonNumber(_thread,x,y) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        
        return (_this.separate32(x)|(_this.separate32(y)<<1));
        
      },
      register :function _trc_QuadTreeManager_register(rect) {
        "use strict";
        var _this=this;
        var p;
        var sx;
        var sy;
        var tx;
        var ty;
        var w;
        var h;
        var sxi;
        var syi;
        var txi;
        var tyi;
        var si;
        var ti;
        var x;
        var m;
        var pInd;
        var pLevel;
        
        p = rect.getCornerPoint();
        
        sx = p[0];
        sy = p[1];
        tx = p[2];
        ty = p[3];
        
        w = Tonyu.globals.$regionW/(1<<_this.maxLevel);
        
        h = Tonyu.globals.$regionH/(1<<_this.maxLevel);
        
        sxi = _this.floor((sx-Tonyu.globals.$regionSx)/w);
        
        syi = _this.floor((sy-Tonyu.globals.$regionSy)/h);
        
        txi = _this.floor((tx-Tonyu.globals.$regionSx)/w);
        
        tyi = _this.floor((ty-Tonyu.globals.$regionSy)/h);
        
        si = _this.get2DMortonNumber(sxi,syi);
        
        ti = _this.get2DMortonNumber(txi,tyi);
        
        x = si^ti;
        
        m = _this.MSB32(x);
        
        m++;
        if (m&1) {
          m++;
        }
        pInd = si>>m;
        
        pLevel = _this.maxLevel-m/2;
        
        _this.treeTable[_this.offsetTable[pLevel]+pInd].push(rect);
      },
      fiber$register :function* _trc_QuadTreeManager_f_register(_thread,rect) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var p;
        var sx;
        var sy;
        var tx;
        var ty;
        var w;
        var h;
        var sxi;
        var syi;
        var txi;
        var tyi;
        var si;
        var ti;
        var x;
        var m;
        var pInd;
        var pLevel;
        
        p = rect.getCornerPoint();
        
        sx = p[0];
        sy = p[1];
        tx = p[2];
        ty = p[3];
        
        w = Tonyu.globals.$regionW/(1<<_this.maxLevel);
        
        h = Tonyu.globals.$regionH/(1<<_this.maxLevel);
        
        sxi = _this.floor((sx-Tonyu.globals.$regionSx)/w);
        
        syi = _this.floor((sy-Tonyu.globals.$regionSy)/h);
        
        txi = _this.floor((tx-Tonyu.globals.$regionSx)/w);
        
        tyi = _this.floor((ty-Tonyu.globals.$regionSy)/h);
        
        si=yield* _this.fiber$get2DMortonNumber(_thread, sxi, syi);
        
        ti=yield* _this.fiber$get2DMortonNumber(_thread, txi, tyi);
        
        x = si^ti;
        
        m=yield* _this.fiber$MSB32(_thread, x);
        
        m++;
        if (m&1) {
          m++;
        }
        pInd = si>>m;
        
        pLevel = _this.maxLevel-m/2;
        
        _this.treeTable[_this.offsetTable[pLevel]+pInd].push(rect);
        
      },
      dfs :function _trc_QuadTreeManager_dfs(v,list,level) {
        "use strict";
        var _this=this;
        var i1;
        var i2;
        var t;
        var i;
        
        if (level>_this.maxLevel) {
          return _this;
          
        }
        for (i1 = 0;
         i1<_this.treeTable[v].length ; i1++) {
          {
            for (i2 = i1+1;
             i2<_this.treeTable[v].length ; i2++) {
              {
                if (_this.doCrashTo(_this.treeTable[v][i1],_this.treeTable[v][i2])) {
                  _this.countUp();
                  
                }
              }
            }
          }
        }
        for (i1 = 0;
         i1<_this.treeTable[v].length ; i1++) {
          {
            for (i2 = 0;
             i2<list.length ; i2++) {
              {
                if (_this.doCrashTo(_this.treeTable[v][i1],list[i2])) {
                  _this.countUp();
                  
                }
              }
            }
          }
        }
        if (level!=_this.maxLevel) {
          for ([t] of Tonyu.iterator2(_this.treeTable[v],1)) {
            list.push(t);
            
          }
          
        }
        _this.dfs(v*4+1,list,level+1);
        _this.dfs(v*4+2,list,level+1);
        _this.dfs(v*4+3,list,level+1);
        _this.dfs(v*4+4,list,level+1);
        for (i = 0;
         i<_this.treeTable[v].length ; i++) {
          {
            list.pop();
          }
        }
      },
      fiber$dfs :function* _trc_QuadTreeManager_f_dfs(_thread,v,list,level) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var i1;
        var i2;
        var t;
        var i;
        
        if (level>_this.maxLevel) {
          return _this;
          
        }
        for (i1 = 0;
         i1<_this.treeTable[v].length ; i1++) {
          {
            for (i2 = i1+1;
             i2<_this.treeTable[v].length ; i2++) {
              {
                if (_this.doCrashTo(_this.treeTable[v][i1],_this.treeTable[v][i2])) {
                  (yield* _this.fiber$countUp(_thread));
                  
                }
              }
            }
          }
        }
        for (i1 = 0;
         i1<_this.treeTable[v].length ; i1++) {
          {
            for (i2 = 0;
             i2<list.length ; i2++) {
              {
                if (_this.doCrashTo(_this.treeTable[v][i1],list[i2])) {
                  (yield* _this.fiber$countUp(_thread));
                  
                }
              }
            }
          }
        }
        if (level!=_this.maxLevel) {
          for ([t] of Tonyu.iterator2(_this.treeTable[v],1)) {
            list.push(t);
            
          }
          
        }
        (yield* _this.fiber$dfs(_thread, v*4+1, list, level+1));
        (yield* _this.fiber$dfs(_thread, v*4+2, list, level+1));
        (yield* _this.fiber$dfs(_thread, v*4+3, list, level+1));
        (yield* _this.fiber$dfs(_thread, v*4+4, list, level+1));
        for (i = 0;
         i<_this.treeTable[v].length ; i++) {
          {
            list.pop();
          }
        }
        
      },
      preProcess :function _trc_QuadTreeManager_preProcess() {
        "use strict";
        var _this=this;
        var i;
        var t;
        
        _this.treeTable=new Array(_this.maxN);
        for (i = 0;
         i<_this.maxN ; i++) {
          {
            _this.treeTable[i]=[];
          }
        }
        for ([t] of Tonyu.iterator2(_this.all(Tonyu.classes.user.Rect),1)) {
          _this.register(t);
          
        }
      },
      fiber$preProcess :function* _trc_QuadTreeManager_f_preProcess(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var i;
        var t;
        
        _this.treeTable=new Array(_this.maxN);
        for (i = 0;
         i<_this.maxN ; i++) {
          {
            _this.treeTable[i]=[];
          }
        }
        for ([t] of Tonyu.iterator2(_this.all(Tonyu.classes.user.Rect),1)) {
          (yield* _this.fiber$register(_thread, t));
          
        }
        
      },
      move :function _trc_QuadTreeManager_move() {
        "use strict";
        var _this=this;
        
        __superClass.prototype.move.apply( _this, []);
        _this.preProcess();
        _this.dfs(0,[],0);
      },
      fiber$move :function* _trc_QuadTreeManager_f_move(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        
        (yield* __superClass.prototype.fiber$move.apply( _this, [_thread]));
        (yield* _this.fiber$preProcess(_thread));
        (yield* _this.fiber$dfs(_thread, 0, [], 0));
        
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false,"isMain":true,"vtype":{"params":[],"returnValue":null}},"init":{"nowait":false,"isMain":false,"vtype":{"params":[],"returnValue":null}},"separate32":{"nowait":false,"isMain":false,"vtype":{"params":[null],"returnValue":null}},"count32bit":{"nowait":false,"isMain":false,"vtype":{"params":[null],"returnValue":null}},"MSB32":{"nowait":false,"isMain":false,"vtype":{"params":[null],"returnValue":null}},"get2DMortonNumber":{"nowait":false,"isMain":false,"vtype":{"params":[null,null],"returnValue":null}},"register":{"nowait":false,"isMain":false,"vtype":{"params":[null],"returnValue":null}},"dfs":{"nowait":false,"isMain":false,"vtype":{"params":[null,null,null],"returnValue":null}},"preProcess":{"nowait":false,"isMain":false,"vtype":{"params":[],"returnValue":null}},"move":{"nowait":false,"isMain":false,"vtype":{"params":[],"returnValue":null}}},"fields":{"treeTable":{},"offsetTable":{},"maxLevel":{},"maxN":{}}}
});
Tonyu.klass.define({
  fullName: 'user.Rect',
  shortName: 'Rect',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Rect_main() {
        "use strict";
        var _this=this;
        
        
        
        _this.init();
        while (1) {
          _this.move();
          _this.draw();
          _this.update();
          
        }
      },
      fiber$main :function* _trc_Rect_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        
        
        
        (yield* _this.fiber$init(_thread));
        while (1) {
          (yield* _this.fiber$move(_thread));
          _this.draw();
          (yield* _this.fiber$update(_thread));
          
        }
        
      },
      getCornerPoint :function _trc_Rect_getCornerPoint() {
        "use strict";
        var _this=this;
        var w2;
        var h2;
        
        w2 = _this.width/2;
        h2 = _this.height/2;
        
        return [_this.x-w2,_this.y-h2,_this.x+w2,_this.y+h2];
      },
      fiber$getCornerPoint :function* _trc_Rect_f_getCornerPoint(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var w2;
        var h2;
        
        w2 = _this.width/2;
        h2 = _this.height/2;
        
        return [_this.x-w2,_this.y-h2,_this.x+w2,_this.y+h2];
        
      },
      init :function _trc_Rect_init() {
        "use strict";
        var _this=this;
        
        _this.vx=(_this.rnd(100)-50)/20;
        _this.vy=(_this.rnd(100)-50)/20;
      },
      fiber$init :function* _trc_Rect_f_init(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        
        _this.vx=(_this.rnd(100)-50)/20;
        _this.vy=(_this.rnd(100)-50)/20;
        
      },
      move :function _trc_Rect_move() {
        "use strict";
        var _this=this;
        var nx;
        var ny;
        var w2;
        var h2;
        
        nx = _this.x+_this.vx;
        ny = _this.y+_this.vy;
        
        w2 = _this.width/2;
        h2 = _this.height/2;
        
        if (nx-w2<Tonyu.globals.$regionSx||nx+w2>=Tonyu.globals.$regionSx+Tonyu.globals.$regionW) {
          _this.vx=- _this.vx;
        }
        if (ny-h2<Tonyu.globals.$regionSy||ny+h2>=Tonyu.globals.$regionSy+Tonyu.globals.$regionH) {
          _this.vy=- _this.vy;
        }
        _this.x+=_this.vx;
        _this.y+=_this.vy;
      },
      fiber$move :function* _trc_Rect_f_move(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var nx;
        var ny;
        var w2;
        var h2;
        
        nx = _this.x+_this.vx;
        ny = _this.y+_this.vy;
        
        w2 = _this.width/2;
        h2 = _this.height/2;
        
        if (nx-w2<Tonyu.globals.$regionSx||nx+w2>=Tonyu.globals.$regionSx+Tonyu.globals.$regionW) {
          _this.vx=- _this.vx;
        }
        if (ny-h2<Tonyu.globals.$regionSy||ny+h2>=Tonyu.globals.$regionSy+Tonyu.globals.$regionH) {
          _this.vy=- _this.vy;
        }
        _this.x+=_this.vx;
        _this.y+=_this.vy;
        
      },
      draw :function _trc_Rect_draw() {
        "use strict";
        var _this=this;
        
        _this.fillRect(_this.x-_this.width/2,_this.y-_this.height/2,_this.width,_this.height,_this.color(247,195,191));
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false,"isMain":true,"vtype":{"params":[],"returnValue":null}},"getCornerPoint":{"nowait":false,"isMain":false,"vtype":{"params":[],"returnValue":null}},"init":{"nowait":false,"isMain":false,"vtype":{"params":[],"returnValue":null}},"move":{"nowait":false,"isMain":false,"vtype":{"params":[],"returnValue":null}},"draw":{"nowait":true,"isMain":false,"vtype":{"params":[],"returnValue":null}}},"fields":{"x":{},"y":{},"width":{},"height":{},"vx":{},"vy":{}}}
});

//# sourceMappingURL=concat.js.map